using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
	public class LaborsofHerculaneumInsane : ScriptServer.IScript
    {
        // for our messaging
        private String msgTitle, msgText;
        private String msgSound = "message1.mp3";
        private String msgApplause = "/../../sounds/events/event_circus_01.wav";
        private String msgRiot = "/../../sounds/events/event_coliseum_05.wav";

        // variables for current ratings
        private uint nFavor, nSecurity, nCulture, nProsperity;
        private Int32 nPopulation, nCityFunds, nSavings;
        private Int32 nMaxPopulation = 0;
        
        // flags to tell us whether specific events have happened
        private bool bMessageSent = false;
        private bool bPatricians = false;
        private bool bChains = false;
        private bool bCavalry = false;
        private bool bArmory = false;
        private bool bColiseum = false;
        private bool bArena = false;
        private bool bTheater = false;
        private bool bOdeum = false;
        private bool bCircus = false;
        private bool bJasonus = true;
        private bool bPortWarn = false;
        
        private bool bPrefects = true;
        private bool bEruption = false;
        private bool bPopWarn = false;
        private bool bDebtWarn = false;
        private bool bObelisk = false;
        private bool bInit = false;

        // variables for wage and population checks
        private int nPlebWages = 18;               // starting wages for plebs
        private int nEquiteWages = 24;             // ...and equites

        // variables for different checks
        private uint nTime = 0;                    // derived from game.GameTime
        private uint tWC1 = 0;                     // for completion time in seconds
        private uint iLabor = 0;                   // this is an index to tell us where we are in the Story
        private uint uLabor = 0;                   // index for unlocking purposes
        private uint tLabor = 40;                  // timer to determine when to move on to the next stage
        private uint iState = 0;
        private uint iCretan = 0;
        private uint tTaenarum = 20;
        private uint iBurn = 0;
        private uint iMessage = 0;
        private uint tWageCheck = 960;
        private uint tVenueCheck = 80;
        private uint tPayCheck = 10;
        private uint tVillaCheck = 50;
        private uint numVillas = 0;
        private uint iWarn = 0;
        private uint nInvasion = 0;
        private uint iInvasion = 0;
        private uint tInvasion = 96000;
        private uint[] nTimerCheck = { 20, 500, 820, 1140, 1460, 1780, 2100, 2420, 2740, 3060, 3380, 3700, 4020, 4340, 4660, 4980, 5300, 5620, 5780, 6260, 6580, 6740, 6980, 7060, 7140, 7220, 999999 };
        private String[] sTimeLeft = { "90", "84", "80", "76", "72", "68", "64", "60", "56", "52", "48", "44", "40", "36", "32", "28", "24", "20", "18", "12", "8", "6", "3", "2", "1", "0", "X" };
        private uint[] tNoVenue = { 0, 0, 0, 0, 0 };
        private uint iOdeum = 0;
        private uint iTheater = 1;
        private uint iArena = 2;
        private uint iColiseum = 3;
        private uint iCircus = 4;

        private uint kTaenarum = 9;
        private uint kDefeat = 10;
        
        // Resource requirements settings (vary for Novice/Easy/Hard/Insane)
        private uint rFurs = 12;
        private uint rJewels = 15;
        private uint rPapyrus = 25;
        private uint rTimber = 25;
        private uint rWeaponry = 30;
        private uint rMeat = 125;
        private uint rIron = 48;
        private uint rGrapes = 44;

        // resource iDs
        private Int32 mIDWine = IDMaker.FromString("c4cr Wine");
        private Int32 mIDFurs = IDMaker.FromString("c4cr Furs");
        private Int32 mIDPapyrus = IDMaker.FromString("c4cr Papyrus");
        private Int32 mIDPerfume = IDMaker.FromString("c4cr Perfume");
        private Int32 mIDCosmetics = IDMaker.FromString("c4cr Cosmetics");
        private Int32 mIDTimber = IDMaker.FromString("c4cr Timber");
        private Int32 mIDJewelry = IDMaker.FromString("c4cr Jewelry");
        private Int32 mIDIron = IDMaker.FromString("c4cr Iron");
        private Int32 mIDGrapes = IDMaker.FromString("c4cr Grapes");
        private Int32 mIDMeat = IDMaker.FromString("c4cr Meat");
        private Int32 mIDArmor = IDMaker.FromString("c4cr Armor");
        private Int32 mIDWeapons = IDMaker.FromString("c4cr Weapons");

        // building IDs
        private Int32 mIDPalace1 = IDMaker.FromString("C4b Governor's Palace Small");
        private Int32 mIDPalace2 = IDMaker.FromString("C4b Governor's Palace Medium");
        private Int32 mIDPalace3 = IDMaker.FromString("C4b Governor's Palace Large");
        private Int32 mIDDomus1 = IDMaker.FromString("C4b Equites Housing 01");
        private Int32 mIDDomus2 = IDMaker.FromString("C4b Equites Housing 02");
        private Int32 mIDDomus3 = IDMaker.FromString("C4b Equites Housing 03");
        private string[] sPatricians = {"C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
             "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06","C4b Patrician home 07",
             "C4b Patrician home 08","C4b Patrician home 09"};
        private Int32 mIDVilla2 = IDMaker.FromString("C4b Patrician home 02");
        private Int32 mIDVilla3 = IDMaker.FromString("C4b Patrician home 03");
        private Int32 mIDEstate1 = IDMaker.FromString("C4b Patrician home 04");
        private Int32 mIDEstate2 = IDMaker.FromString("C4b Patrician home 05");
        private Int32 mIDEstate3 = IDMaker.FromString("C4b Patrician home 06");
        private Int32 mIDMansion1 = IDMaker.FromString("C4b Patrician home 07");
        private Int32 mIDMansion2 = IDMaker.FromString("C4b Patrician home 08");
        private Int32 mIDMansion3 = IDMaker.FromString("C4b Patrician home 09");
        private Int32 mIDForum = IDMaker.FromString("C4b service Forum");
        private Int32 mIDBasilica = IDMaker.FromString("C4b service Basilica");
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
           
        private Int32 mIDOdeum = IDMaker.FromString("C4b service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b service Arena");
        private Int32 mIDColiseum = IDMaker.FromString("C4b service Coliseum");
        private Int32 mIDCircus = IDMaker.FromString("C4b service Circus");
        private Int32 mIDLibrary = IDMaker.FromString("C4b service Library");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDPrefect = IDMaker.FromString("C4b Office Praefect");
        private Int32 mIDCattleFarm = IDMaker.FromString("C4b harvester Livestock farmer's house");
        private Int32 mIDSheepFarm = IDMaker.FromString("C4b harvester Wool farmer's house");
        private Int32 mIDArmorFactory = IDMaker.FromString("C4b factory Armor");
        private Int32 mIDWeaponFactory = IDMaker.FromString("C4b factory Weapons");
        private Int32 mIDPort = IDMaker.FromString("C4b Depot with Dock");
        
        private Int32 mIDMessHall = IDMaker.FromString("C4b Mil Mess Hall");
        private Int32 mIDAuxFort = IDMaker.FromString("C4b Mil Fort Auxilia");
        private Int32 mIDCavFort = IDMaker.FromString("C4b Mil Fort Auxilia Cavalry");
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        private Int32 mIDArmory = IDMaker.FromString("C4b Mil Armory");
        private Int32 mIDBushSmall = IDMaker.FromString("C4 Deco Bush Small");
        private Int32 mIDBushLarge = IDMaker.FromString("C4 Deco Bush Large");
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        
        // build button IDs
        private Int32 mUIIDTaxman = 276325360;
        private Int32 mUIIDOdeum = 1740942627;
        private Int32 mUIIDArena = 1724165050;
        private Int32 mUIIDGladiator = 1806783075;
        private Int32 mUIIDColiseum = 1691448420;
        private Int32 mUIIDCircus = -2046596977;
        private Int32 mUIIDSchool = -1298997109;
        private Int32 mUIIDLibrary = -1298997110;
        private Int32 mUIIDBarber = -1282219398;
        private Int32 mUIIDBathhouse = -1282219397;
        private Int32 mUIIDHospital = -1282219393;
        private Int32 mUIIDForum = 293102951;
        private Int32 mUIIDBasilica = 276325373;
        private Int32 mUIIDIronMine = 1389655977;
        private Int32 mUIIDMarble = -896256229;
        private Int32 mUIIDGrapeFarm = -187939099;
        private Int32 mUIIDPrefect = 276325365;

        private Int32 mUIIDPatHome = IDMaker.FromString("PAT_HOME");
        private Int32 mUIIDExoticMarket = IDMaker.FromString("MARKET_EXOTIC");
        private Int32 mUIIDBushSmall = IDMaker.FromString("DECO2");
        private Int32 mUIIDBushLarge = IDMaker.FromString("DECO4");
        private Int32 mUIIDObelisk = IDMaker.FromString("PRESALE1");
        private Int32 mUIIDFortCavalry = IDMaker.FromString("FORT_CAV");
        private Int32 mUIIDFortArcher = IDMaker.FromString("FORT_AUX");
        private Int32 mUIIDMessHall = IDMaker.FromString("MIL_MESS_HALL");
        private Int32 mUIIDArmory = IDMaker.FromString("MIL_ARMORY");
        private Int32 mUIIDDrillYard = IDMaker.FromString("MIL_DRILL_YARD");
        private Int32 mUIIDGateHouse = -879510213; 
        private Int32 mUIIDWage1 = 557539675;
        private Int32 mUIIDWage2 = 557539672;
        private Int32 mUIIDWage3 = -1985153394;
        private Int32 mUIIDWage4 = -1985153399;

        // The following declarations are necessary as this scenario uses custom standward wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;

        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;
        // This is the main script loop
        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch(gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        {
            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
                game.ScriptDone = false;
            }
            else
                CheckBaseUI(game);

            bMessageSent = false;
            // Set our city ratings
            GetCityRatings(game);

            if (nTimerCheck[iMessage] < 10000)
            {
                if (nTime > nTimerCheck[iMessage]) TimerMessage(game);
            }
            else if (iBurn < 14)
                VolcanoDay(game);

            if ((nTime > tTaenarum) && (!bChains)) CheckTaenarum(game);

            // This is where all the labor sequence will go!
            if (bJasonus && (nTime > tLabor))
            {
                if (iLabor > 0)
                    LaborStory(game);
                else
                    LaborStart(game);
            }
            else if (nTime > tInvasion)
                MadGeeks(game);

            // Entertainment venues must be active!
            if ((iLabor > 0) && (iLabor < 13))
            {
                if (nTime > tVenueCheck)
                    CheckVenues(game);
                else if (nTime > tVillaCheck)
                    CheckVillas(game);
            }

            // check to see if player is paying more than the rank justifies
            if (!bMessageSent && (nTime > tPayCheck)) SalaryCheck(game);

            // are wage expectations raised?
            if (!bMessageSent && (nTime > tWageCheck))
                CheckWageExpectations(game);

            // obelisk award
            if (!bMessageSent && !bObelisk) ObeliskAward(game); 

            mMilitaryAI.Update(game, 0.1);
        }

        ////////////////////////////////////////////////
        // This is where we get the city ratings etc
        void GetCityRatings(IGameQueryInterface game)
        {
            nTime = game.GameTime / 1000;           // time measured in seconds
            game.GetFavorRating(out nFavor);
            game.GetCultureRating(out nCulture);
            game.GetSecurityRating(out nSecurity);
            game.GetProsperityRating(out nProsperity);
            game.GetPopulation(out nPopulation);
            game.GetCityFunds(out nCityFunds);
            game.GetGovernorPersonalFunds(out nSavings);
            if (nPopulation > nMaxPopulation) nMaxPopulation = nPopulation;
            if ((iLabor > 12) && (nCulture >= 95) && (nCityFunds >= 0) && (tWC1 == 0)) tWC1 = nTime;
            if (nCityFunds < 0) game.ScriptDone = false;

            // Calculate the number of patricians
            uint num;
            Int32 mID;
            numVillas = 0;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                numVillas += num;
            }
            if (numVillas > 3)
                game.LockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            else if (iLabor > 0)
                game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            
            // check for defeat conditions
            if ((nPopulation > 4999) || (nCityFunds < -2500) || (nTime > 7300))
            {
                game.OpenTradeRoute(kDefeat);
                game.ScriptDone = true;
            }
            else if (!bPopWarn && (nPopulation > 4500))
            {
                bPopWarn = true;
                DisplayMessage(game, "Population");
            }
            else if (!bDebtWarn && (nCityFunds < -1000))
            {
                bDebtWarn = true;
                DisplayMessage(game, "Debt");
            }
        }

        ////////////////////////////////////////////
        // Checks for inactive venues
        void CheckVenues(IGameQueryInterface game)
        {
            uint iLevel, iVL = 0;
            iLevel = 0;
            
            if (bOdeum)         
                iLevel = tInactiveVenue(game, 0, 1, 2, 3);

            // Theater Check
            if (bTheater)
            {
                iVL = tInactiveVenue(game, 1, 2, 4, 6);
                if (iVL > iLevel) iLevel = iVL;
            }

            if (bArena)
            {
                iVL = tInactiveVenue(game, 2, 3, 5, 7);
                if (iVL > iLevel) iLevel = iVL;
            }

            if (bColiseum)
            {
                iVL = tInactiveVenue(game, 3, 3, 5, 7);
                if (iVL > iLevel) iLevel = iVL;
            }

            if (bCircus)
            {
                iVL = tInactiveVenue(game, 4, 3, 5, 7);
                if (iVL > iLevel) iLevel = iVL;
            }

            switch (iLevel)
            {
                case 0:
                    if (!bJasonus)
                    {
                        DisplayMessage(game, "Jasonus_Back");
                        bJasonus = true;
                    }
                    break;

                case 1:
                    if (bJasonus)
                    {
                        String sJason = "/../../Voice/Figures/actors_guild_01.mp3";
                        DisplaySMessage(game, "Jasonus_Strike", sJason);
                        bJasonus = false;
                    }
                    break;

                case 2:
                    DisplayMessage(game, "Fans_Unhappy");
                    break;

                case 3:
                    DisplayRiot(game, "Fans_Riot");
                    break;

                case 4:
                    break;
            }
            tVenueCheck += 20;
        }

        ////////////////////////////////////////////
        // Time of entertainment venue inactivity
        uint tInactiveVenue(IGameQueryInterface game, uint iVenue, uint iWarn, uint iUnhappy, uint iRiot)
        {
            Int32[] mID = { mIDOdeum, mIDTheater, mIDArena, mIDColiseum, mIDCircus };
            String[] sEMsg = { "No_Odeum", "No_Theater", "No_Arena", "No_Coliseum", "No_Circus" };
            uint nVenue, iVL = 0;

            game.GetActiveBuildings(mID[iVenue], out nVenue);
            if (nVenue == 0)
            {
                tNoVenue[iVenue]++;
                if (tNoVenue[iVenue] >= iRiot)
                {
                    game.GetTotalBuildings(mID[iVenue], out nVenue);
                    if (nVenue > 0)
                    {
                        iVL = 3;
                        game.TriggerFireDamage(mID[iVenue], 1, 99);
                        tNoVenue[iVenue] = 0;
                    }
                    else
                        iVL = 1;
                }
                else if (tNoVenue[iVenue] == iUnhappy)
                    iVL = 2;
                else if (tNoVenue[iVenue] >= iWarn)
                {
                    iVL = 1;
                    if (tNoVenue[iVenue] == iWarn) SilentWarning(game, sEMsg[iVenue]);
                }
                else
                    iVL = 0;
            }
            else
                tNoVenue[iVenue] = 0;

            return iVL;
        }

        ////////////////////////////////////////////////
        // Fighting over Jasonus if more than 4 villas
        void CheckVillas(IGameQueryInterface game)
        {
            uint num = 0;
            Int32 mID = 0;
            tVillaCheck = nTime + 20;

            if (numVillas > 4)
            {
                for (int i = 0; i < 9; i++)
                {
                    mID = IDMaker.FromString(sPatricians[i]);
                    game.GetTotalBuildings(mID, out num);
                    if (num > 0)
                    {
                        game.TriggerStructureDamage(mID, 1, 99);
                        break;
                    }
                }
                DisplayRiot(game, "Villa_Kablooey");
            }
        }

        ////////////////////////////////////////////
        // Checks for premature opening of Taenarum
        void CheckTaenarum(IGameQueryInterface game)
        {
            bool bOpen = false;
            game.GetIsTradeRouteOpen(9, out bOpen);
            if (bOpen)
            {
                DisplayMessage(game, "Taenarum_P");
                game.CloseTradeRoute(9);
                tTaenarum = nTime + 20;
            }
        }

        ////////////////////////////////////////////
        // 50 culture gets you the obelisk
        void ObeliskAward(IGameQueryInterface game)
        {
            if (nCulture >= 50)
            {
                DisplayMessage(game, "Obelisk");
                game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
                bObelisk = true;
            }
        }

        /////////////////////////////////////////
        // This introduces the Labor tale
        void LaborStart(IGameQueryInterface game)
        {
            game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            DisplayTutorial(game);
            iLabor++;
            iState = 0;
            tLabor += 20;
        }

        //////////////////////////////////////////////////////////////////
        // This controls the Labor sequence based on the value of iLabor
        void LaborStory(IGameQueryInterface game)
        {
            uint nB1, nB2, nB3, nB4, nR1, nR2;
            Int32 mID = 0;
            
            switch (iLabor)
            {
                case 1:
                    // First Labor - Nemean Lion
                    // First we need Hercules
                    if (iState == 0)
                    {
                        game.GetTotalBuildings(mIDVilla2, out nB1);
                        if (nB1 > 0) iState++;
                    }
                    else if (iState == 1)
                    {
                        bTheater = true;
                        uLabor = 1;
                        game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                        DisplayTutorial(game);
                        iState++;
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDColiseum, out nB1);
                        if (nB1 > 0)
                        {
                            bColiseum = true;
                            LaborDone(game);
                        }
                    }
                    break;

                case 2:
                    // Second Labor - Lernean Hydra
                    // First Hercules must push apart the rocks!
                    if (iState == 0)
                        DisplayTutorial(game);
                    else if (iState == 1)
                    {
                        Int32 mQuake = IDMaker.FromString("Short Earthquake");
                        game.TriggerDisasterEffect(mQuake);
                        DisplayMessage(game, "Rocks");
                        uLabor = 2;
                        game.UnlockUIControl(-520227242, Toolset.EmpireLevelFormID);
                        tVenueCheck = nTime + 20;
                        iState++;
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDPort, out nB1);
                        game.GetTotalBuildings(mIDVilla2, out nB2);
                        game.GetResource(mIDWine, out nR1);
                        if ((nB1 > 7) && (nB2 > 0) && (nR1 > 3))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 8)
                            {
                                if (nR1 < 4) SilentWarning(game, "Jasonus_Wine");
                            }
                            else if (iWarn == 16)
                            {
                                if (nB1 < 8) SilentWarning(game, "Hydra_Ports");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 3:
                    // Cerynean hind... furs and jewelry!
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDBarber, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDBathhouse, Toolset.MainGameFormID);
                        game.LockUIControl(mUIIDWage2, Toolset.AdvisorsFormID);
                        game.LockUIControl(mUIIDWage4, Toolset.AdvisorsFormID);
                        DisplayTutorial(game);
                        uLabor = 3;
                        iWarn = 0;
                    }
                    else
                    {
                        game.GetResource(mIDFurs, out nR1);
                        game.GetResource(mIDJewelry, out nR2);
                        game.GetTotalBuildings(mIDVilla3, out nB1);
                        if ((nR1 >= rFurs) && (nR2 >= rJewels) && (nB1 > 0))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 8)
                            {
                                if (nR1 < rFurs) SilentWarning(game, "Jasonus_Furs");
                            }
                            else if (iWarn == 12)
                            {
                                if (nR2 < rJewels) SilentWarning(game, "Jasonus_Jewels");
                            }
                            else if (iWarn == 16)
                            {
                                if (nB1 < 1) SilentWarning(game, "Jasonus_Villa3");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 4:
                    // Erymanthean Bore!...
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
                        uLabor = 4;
                    }
                    else
                    {
                        game.GetResource(mIDPapyrus, out nR1);
                        game.GetTotalBuildings(mIDEstate1, out nB1);
                        if ((nR1 >= rPapyrus) && (nB1 > 0)) LaborDone(game);
                    }
                    break;

                case 5:
                    // Stables of Augeias...
                    if (iState == 0)
                        DisplayTutorial(game);
                    else if (iState == 1)
                    {
                        game.GetResource(mIDWeapons, out nR1);
                        game.GetResource(mIDArmor, out nR2);
                        if ((nR1 >= 20) && (nR2 >= 20))
                        {
                            bArmory = true;
                            DisplayMessage(game, "Recruit");
                            game.UnlockUIControl(mUIIDArmory, Toolset.MainGameFormID);
                            iState++;
                        }
                    }
                    else if (iState == 2)
                    {
                        game.GetActiveBuildings(mIDArmory, out nB1);
                        if (nB1 > 0)
                        {
                            bCavalry = true;
                            DisplayMessage(game, "Cavalry");
                            game.UnlockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
                            game.UnlockUIControl(mUIIDDrillYard, Toolset.MainGameFormID);
                            tLabor = nTime + 75;
                            iState++;
                        }
                    }
                    else if (iState == 3)
                    {
                        DisplayMessage(game, "Greeks_Mad");
                        iState++;
                        tLabor = nTime + 55;
                        iWarn = 0;
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDCavFort, out nB1);
                        game.GetActiveBuildings(mIDSheepFarm, out nB2);
                        game.GetActiveBuildings(mIDCattleFarm, out nB3);
                        game.GetTotalBuildings(mIDEstate1, out nB4);
                        game.GetResource(mIDTimber, out nR1);
                        if ((nB1 > 0) && (nB2 > 0) && (nB3 > 0) && (nB4 > 0) && (nR1 >= rTimber))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 4)
                            {
                                if (nB1 < 1) SilentWarning(game, "Cavalry_Fort");
                            }
                            else if (iWarn == 8)
                            {
                                if (nB2 < 1) SilentWarning(game, "Jasonus_Sheep");
                            }
                            else if (iWarn == 12)
                            {
                                if (nR1 < rTimber) SilentWarning(game, "Jasonus_Brooms");
                            }
                            else if (iWarn == 16)
                            {
                                if (nB3 < 1) SilentWarning(game, "Jasonus_Cows");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 6:
                    // Stymphalian Birds...
                    if (iState == 0)
                    {
                        DisplayMessage(game, "Quarry");
                        game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                        uLabor = 6;
                        iState++;
                    }
                    else if (iState == 1)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDOdeum, Toolset.MainGameFormID);
                        nInvasion = 1;
                        iInvasion = 0;
                        tInvasion = nTime + 50;
                        iWarn = 0;
                    }
                    else
                    {
                        uint rOdeum = (uint)nPopulation / 1000 + 1;
                        game.GetTotalBuildings(mIDStatue6, out nB1);
                        game.GetActiveBuildings(mIDOdeum, out nB2);
                        game.GetActiveBuildings(mIDMarsTemple, out nB3);
                        game.GetTotalBuildings(mIDEstate1, out nB4);
                        game.GetResource(mIDPerfume, out nR1);
                        if (nB2 > 0) bOdeum = true;
                        if ((nB1 > 5) && (nB2 >= rOdeum) && (nB3 > 0) && (nB4 > 0) && (nR1 > 3))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 4)
                            {
                                if (nB2 < rOdeum) SilentWarning(game, "Jasonus_Odeums");
                            }
                            else if (iWarn == 8)
                            {
                                if (nB3 < 1) SilentWarning(game, "Jasonus_Mars");
                            }
                            else if (iWarn == 12)
                            {
                                if (nB1 < 6) SilentWarning(game, "Jasonus_Statues");
                            }
                            else if (iWarn == 16)
                            {
                                if (nR1 < 4) SilentWarning(game, "Jasonus_Perfume");
                            }
                            else if (iWarn == 20)
                            {
                                if (nB4 < 1) SilentWarning(game, "Jasonus_Estate1");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 7:
                    // Cretan Bull
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDForum, Toolset.MainGameFormID);
                        uLabor = 7;
                    }
                    else if (iState == 1)
                    {
                        game.GetActiveBuildings(mIDArena, out nB1);
                        if (nB1 > 0)
                        {
                            DisplayMessage(game, "Arena");
                            bArena = true;
                            iState++;
                        }
                    }
                    else if (iState == 2)
                    {
                        game.GetActiveBuildings(mIDCattleFarm, out nB1);
                        game.GetActiveBuildings(mIDPrefect, out nB2);
                        if (nB2 < 7) nB2 = 7;
                        if (nB1 > 0)
                        {
                            game.TriggerFireDamage(mIDPrefect, (int)nB2, 100);
                            game.LockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                            bPrefects = false;
                            DisplayMessage(game, "Cretan_Bull");
                            tLabor = nTime + 35;
                            iState++;
                        }
                    }
                    else if (iState == 3)
                    {
                        DisplayMessage(game, "Cattle_Riot");
                        game.TriggerFireDamage(mIDCattleFarm, 1, 90);
                        bPrefects = true;
                        game.UnlockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                        tLabor = nTime + 35;
                        iState++;
                    }
                    else
                    {
                        bool bFire = true;
                        game.GetBuildingsOnFire(out bFire);
                        game.GetTotalBuildings(mIDEstate2, out nB1);
                        if (bFire && (iCretan < 24))
                        {
                            if ((iCretan == 4) || (iCretan == 10) || (iCretan == 18))
                                SilentWarning(game, "Put_Out_Fires");
                        }
                        else if (nB1 > 0)
                            LaborDone(game);
                        iCretan++;
                    }
                    break;

                case 8:
                    // Mares of Diomedes... Circus needed!
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDCircus, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDSchool, Toolset.MainGameFormID);
                        uLabor = 8;
                        DisplayTutorial(game);
                    }
                    else if (iState == 1)
                    {
                        game.TriggerStructureDamage(mIDForum, 1, 99);
                        DisplayRiot(game, "Forum_Riot");
                        iState++;
                    }
                    else if (iState == 2)
                    {
                        game.GetActiveBuildings(mIDCircus, out nB1);
                        if (nB1 > 0)
                        {
                            bCircus = true;
                            mID = IDMaker.FromString("C4b harvester Marble collector's camp");
                            game.TriggerStructureDamage(mID, 4, 99);
                            DisplayRiot(game, "Marble");
                            iState++;
                        }
                    }
                    else
                    {
                        game.GetActiveBuildings(mIDCircus, out nB1);
                        game.GetTotalBuildings(mIDEstate3, out nB2);
                        if ((nB1 > 0) && (nB2 > 0)) LaborDone(game);
                    }
                    break;

                case 9:
                    // Hippolyte's Girdle... 3 archer forts and walled in city
                    // Latter is detected by Jasonus having a small or medium mansion
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDGateHouse, Toolset.MainGameFormID);
                        uLabor = 9;
                        DisplayTutorial(game);
                        iWarn = 1;
                    }
                    else if (iState == 1)
                    {
                        game.GetActiveBuildings(mIDAuxFort, out nB1);
                        game.GetActiveBuildings(mIDArmory, out nB2);
                        game.GetResource(mIDWeapons, out nR1);
                        if ((nB1 > 2) && (nB2 > 0) && (nR1 >= rWeaponry))
                        {
                            nInvasion = 2;
                            iInvasion = 0;
                            tInvasion = nTime + 10;
                            tLabor = nTime + 135;
                            iWarn = 4;
                            iState++;
                        }
                        else
                        {
                            if (iWarn == 8)
                            {
                                if (nB1 < 3)
                                    SilentWarning(game, "Jasonus_Archers");
                                else if (nR1 < rWeaponry)
                                    SilentWarning(game, "Jasonus_Weapons");
                                else if (nB2 < 1)
                                    SilentWarning(game, "Jasonus_Armory");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    else
                    {
                        game.GetTotalBuildings(mIDMansion1, out nB1);
                        game.GetTotalBuildings(mIDMansion2, out nB2);
                        nB3 = nB1 + nB2;
                        if (!game.AnyActiveInvasions && (nB3 > 0))
                            LaborDone(game);
                        else if (!game.AnyActiveInvasions)
                        {
                            if (iWarn == 6)
                            {
                                SilentWarning(game, "Jasonus_Mansion");
                                iWarn = 0;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 10:
                    // Cattle of Geryon... LOTS of meat
                    if (iState == 0)
                    {
                        DisplayTutorial(game);
                        iWarn = 0;
                    }
                    else
                    {
                        game.GetTotalBuildings(mIDMansion1, out nB1);
                        game.GetTotalBuildings(mIDMansion2, out nB2);
                        nB3 = nB1 + nB2;
                        game.GetResource(mIDMeat, out nR1);
                        game.GetResource(mIDCosmetics, out nR2);
                        if ((nR1 >= rMeat) && (nB3 > 0) && (nR2 >= 4))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 8)
                            {
                                if (nR1 < rMeat) SilentWarning(game, "Jasonus_Meat");
                            }
                            else if (iWarn == 12)
                            {
                                if (nR2 < 4) SilentWarning(game, "Jasonus_Cosmetics");
                                iWarn = 4;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 11:
                    // Apples of Hesperides... grapes and bushes!
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDGrapeFarm, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDBushSmall, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDBushLarge, Toolset.MainGameFormID);
                        uLabor = 11;
                        DisplayTutorial(game);
                        iWarn = 0;
                    }
                    else if (iState == 1)
                    {
                        mID = IDMaker.FromString("C4b Statue Obelisk");
                        game.GetTotalBuildings(mID, out nB1);
                        if (nB1 == 0)
                            VenusWrath(game);
                        else
                            DisplayWarning(game, "Venus_Pleased");
                        iState++;
                    }
                    else if (iState == 2)
                    {
                        mID = IDMaker.FromString("C4b Market Exotic");
                        game.TriggerFireDamage(mID, 1, 75);
                        DisplayRiot(game, "Exotic_Riot");
                        iState++;
                    }
                    else
                    {
                        game.GetResource(mIDGrapes, out nR1);
                        game.GetTotalBuildings(mIDBushSmall, out nB1);
                        game.GetTotalBuildings(mIDBushLarge, out nB2);
                        game.GetTotalBuildings(mIDMansion1, out nB3);
                        game.GetTotalBuildings(mIDMansion2, out nB4);
                        nR2 = nR1 + nB1 + nB2;
                        if ((nR1 > rGrapes) && (nB1 > 21) && (nB2 > 21) && (nR2 >= 99) && ((nB3 + nB4) > 0))
                            LaborDone(game);
                        else
                        {
                            if (iWarn == 8)
                            {
                                if (nB1 < 22) SilentWarning(game, "Jasonus_Bush1");
                            }
                            else if (iWarn == 12)
                            {
                                if (nB2 < 22) SilentWarning(game, "Jasonus_Bush2");
                            }
                            else if (iWarn == 16)
                            {
                                if (nR1 < rGrapes) SilentWarning(game, "Jasonus_Grapes");
                            }
                            else if (iWarn == 20)
                            {
                                if (nR2 < 99) SilentWarning(game, "Jasonus_99");
                                iWarn = 4;
                            }
                            iWarn++;
                        }
                    }
                    break;

                case 12:
                    // Cerberus... iron for chains + expedition to Tenaerum + Coliseum
                    if (iState == 0)
                    {
                        game.UnlockUIControl(mUIIDIronMine, Toolset.MainGameFormID);
                        game.UnlockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
                        uLabor = 12;
                        DisplayTutorial(game);
                        nInvasion = 3;
                        iInvasion = 0;
                        tInvasion = nTime + 20;
                    }
                    else if (iState == 1)
                    {
                        game.GetResource(mIDIron, out nR1);
                        if (nR1 >= rIron)
                        {
                            bChains = true;
                            DisplayMessage(game, "Chains");
                            iState++;
                        }
                    }
                    else if (iState == 2)
                    {
                        bool bOpen = false;
                        game.GetIsTradeRouteOpen(9, out bOpen);
                        if (bOpen)
                        {
                            DisplayMessage(game, "Taenarum");
                            iState++;
                            tLabor = nTime + 35;
                        }
                    }
                    else if (iState == 3)
                    {
                        game.GetActiveBuildings(mIDColiseum, out nB1);
                        if (nB1 > 0)
                        {
                            DisplayMessage(game, "Cerberus");
                            iState++;
                        }
                    }
                    else
                    {
                        game.GetTotalBuildings(mIDMansion3, out nB1);
                        if (nB1 > 0) LaborDone(game);
                    }
                    break;

                case 13:
                    if ((!bEruption) && (nCityFunds >= 0)) game.ScriptDone = true;
                    break;
            }
            tLabor += 5;

        }

        //////////////////////////////////////////
        // Send 'labor done message' to player
        void LaborDone(IGameQueryInterface game)
        {
            string msgBegin = "Done_" + iLabor.ToString();
            string sDone;
            string[] sIndex = { "01", "22", "12", "29", "11", "22", "11", "29", "22", "28", "22", "11", "29" };
            sDone = "/../../Voice/Figures/actor_" + sIndex[iLabor] + ".mp3";
            DisplaySMessage(game, msgBegin, sDone);
            iLabor++;
            iState = 0;
        }

        //////////////////////////////////////////////
        // Venus destroys all minor god worship venues
        void VenusWrath(IGameQueryInterface game)
        {
            Int32 mID = 0;
            DisplayRiot(game, "Venus_Wrath");
            mID = IDMaker.FromString("C4b Service Shrine Mars");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Temple Mars");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Shrine Mercury");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Temple Mercury");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Shrine Bacchus");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Temple Bacchus");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Shrine Ceres");
            game.TriggerFireDamage(mID, 9, 90);
            mID = IDMaker.FromString("C4b Service Temple Ceres");
            game.TriggerFireDamage(mID, 9, 90);
        }

        ///////////////////////////////////////////////
        // Controls the Mad geek invasions
        void MadGeeks(IGameQueryInterface game)
        {
            InvasionSetup mInvasion;
            String invasion;

            switch (nInvasion)
            {
                case 1:
                    if (iInvasion == 0)
                    {
                        DisplayMessage(game, "Geeks1_W");
                        tInvasion = nTime + 80;
                        iInvasion++;
                    }
                    else if (iInvasion == 1)
                    {
                        tInvasion = 96000;
                        iInvasion++;
                        DisplayMessage(game, "Geeks1_I");
                        invasion = "invasion0";
                        mInvasion = new InvasionSetup(invasion, "Greek", eInvasionType.kInvasion, 0, 4, 0);
                        mInvasion.AddCohort("ENEMY_GREEK_LT", 2, 5, 5);
                        mInvasion.CreateInvasion(game, 0, 0);
                        game.StartInvasion(ref invasion);
                    }
                    break;

                case 2:
                    if (iInvasion == 0)
                    {
                        DisplayMessage(game, "Geeks2_W");
                        tInvasion = nTime + 80;
                        iInvasion++;
                    }
                    else if (iInvasion == 1)
                    {
                        tInvasion = 96000;
                        iInvasion++;
                        DisplayMessage(game, "Geeks2_I");
                        invasion = "invasion1";
                        mInvasion = new InvasionSetup(invasion, "Greek", eInvasionType.kInvasion, 0, 4, 0);
                        mInvasion.AddCohort("ENEMY_GREEK_AUX", 4, 5, 5);
                        mInvasion.CreateInvasion(game, 1, 0);
                        game.StartInvasion(ref invasion);
                    }
                    break;

                case 3:
                    if (iInvasion == 0)
                    {
                        DisplayMessage(game, "Geeks3_W");
                        tInvasion = nTime + 80;
                        iInvasion++;
                    }
                    else if (iInvasion == 1)
                    {
                        tInvasion = 96000;
                        iInvasion++;
                        DisplayMessage(game, "Geeks3_I");
                        invasion = "invasion2";
                        mInvasion = new InvasionSetup(invasion, "Greek", eInvasionType.kInvasion, 0, 4, 0);
                        mInvasion.AddCohort("ENEMY_GREEK_LT", 3, 5, 5);
                        mInvasion.AddCohort("ENEMY_GREEK_AUX", 2, 5, 5);
                        mInvasion.CreateInvasion(game, 2, 0);
                        game.StartInvasion(ref invasion);
                    }
                    break;

            }
        }

        ///////////////////////////////////////////////
        // Volcanic eruption destroys the city (almost)
        // City buildings set on fire in sequence
        void VolcanoDay(IGameQueryInterface game)
        {
            if (!bEruption)
            {
                bEruption = true;
                tVenueCheck = 9999999;
                DisplayMessage(game, "Volcano_Day");
                Int32 mIDBlizzard = IDMaker.FromString("BLIZZARD");
                game.TriggerWeatherEffect(mIDBlizzard);
            }
            else if (nTime > 7240)
                CityBurns(game);

        }

        ///////////////////////////////////////////////
        // Volcanic eruption destroys the city (almost)
        // City buildings set on fire in sequence
        void CityBurns(IGameQueryInterface game)
        {
            int i = 0;
            string[] sFarm = {"C4b harvester Grain farmer's house", "C4b harvester Vegetable farmer's house",  
             "C4b harvester Livestock farmer's house","C4b harvester Olives farmer's house", 
             "C4b harvester Grape farmer's house", "C4b harvester Wool farmer's house"};
            string[] sGatherer = {"C4b harvester Clay collector's house", "C4b harvester Timber miller's house",
                "C4b harvester Iron miner's house", "C4b harvester Gold miner's house", "C4b harvester Marble collector's camp"};
            string[] sFactory = {"C4b factory Pottery", "C4b factory Clothing", "C4b factory Olive Oil",
                "C4b factory Wine","C4b factory Furniture"};
            string[] sStorage = {"C4b infra Granary","C4b infra Warehouse","C4b Depot", "C4b Depot with Dock", 
             "C4b Market Food", "C4b market Common", "C4b Market Luxury", "C4b Market Exotic"};
            string[] sSGovt =  {"C4b Office Engineer","C4b Office Praefect","C4b Office Tax Collector",
             "C4b service Basilica"};
            string[] sLGovt =  {"C4b service Forum","C4b Governor's Palace Small","C4b Governor's Palace Medium",
             "C4b Governor's Palace Large"};
            string[] sWorship = {"C4b Service Shrine Jupiter","C4b Service Temple Jupiter","C4b Service Shrine Mars",
             "C4b Service Temple Mars", "C4b Service Shrine Mercury","C4b Service Temple Mercury",
             "C4b Service Shrine Bacchus","C4b Service Temple Bacchus", "C4b Service Shrine Ceres",
             "C4b Service Temple Ceres"};
            string[] sEnt = {"C4b service Odeum","C4b service Theater","C4b service Arena","C4b Training Actor",
             "C4b Training Animal","C4b Training Gladiator","C4b Training Charioteer"};
            string[] sPlebs = { "C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03" };
            string[] sEquites = { "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03" };
            string[] sService = {"C4b service Barber shop","C4b service Bathhouse","C4b service Clinic",
             "C4b service Hospital","C4b service School","C4b service Library"};
            string[] sMilitary = {"C4b Mil Mess Hall", "C4b Mil Armory", "C4b Mil Drill Yard", 
             "C4b Mil Fort Auxilia", "C4b Mil Fort Auxilia Cavalry"};

            if (iBurn == 0)
            {
                // storage
                for (i = 0; i < 8; i++) TorchBuilding(sStorage[i], game);
            }
            else if (iBurn == 1)
            {
                // plebs
                for (i = 0; i < 3; i++) TorchBuilding(sPlebs[i], game);
            }
            else if (iBurn == 2)
            {
                // farms
                for (i = 0; i < 6; i++) TorchBuilding(sFarm[i], game);
            }
            else if (iBurn == 3)
            {
                // factories
                for (i = 0; i < 5; i++) TorchBuilding(sFactory[i], game);
            }
            else if (iBurn == 4)
            {
                // gatherers & small government buildings
                for (i = 0; i < 5; i++) TorchBuilding(sGatherer[i], game);
                for (i = 0; i < 4; i++) TorchBuilding(sSGovt[i], game);
            }
            else if (iBurn == 5)
            {
                // equites
                for (i = 0; i < 3; i++) TorchBuilding(sEquites[i], game);
            }
            else if (iBurn == 6)
            {
                // entertainment (small)
                for (i = 0; i < 7; i++) TorchBuilding(sEnt[i], game);
            }
            else if (iBurn == 7)
            {
                // education & health
                for (i = 0; i < 6; i++) TorchBuilding(sService[i], game);
            }
            else if (iBurn == 8)
            {
                // villas
                for (i = 0; i < 9; i++) TorchBuilding(sPatricians[i], game);
            }
            else if (iBurn == 9)
            {
                // large government
                for (i = 0; i < 4; i++) TorchBuilding(sLGovt[i], game);
            }
            else if (iBurn == 10)
            {
                // worship
                for (i = 0; i < 10; i++) TorchBuilding(sWorship[i], game);
            }
            else if (iBurn == 11)
            {
                // military
                for (i = 0; i < 5; i++) TorchBuilding(sMilitary[i], game);
            }
            else if (iBurn == 12)
            {
                TorchBuilding("C4b Service Coliseum", game);
            }
            else if (iBurn == 13)
            {
                TorchBuilding("C4b Service Circus", game);
            }
            iBurn++;
        }

        //////////////////////////////////////////////////////////////
        // This sets fire to all buildings of the specified type
        void TorchBuilding(String sBuilding, IGameQueryInterface game)
        {
            UInt32 num = 0;
            Int32 mID = IDMaker.FromString(sBuilding);
            game.GetTotalBuildings(mID, out num);
            if (num > 0) game.TriggerFireDamage(mID, (int)num, 80);
        }

        ///////////////////////////////////////////
        // Check for an overpaid Governor
        void SalaryCheck(IGameQueryInterface game)
        {
            uint gRank, gSalary, n1, n2, n3;
            game.GetGovernorRank(out gRank);
            game.GetGovernorSalaryLevel(out gSalary);
            
            if (gSalary > gRank)
            {
                game.GetTotalBuildings(mIDTaxOffice, out n1);
                game.GetTotalBuildings(mIDForum, out n2);
                game.GetTotalBuildings(mIDBasilica, out n3);
                Int32 mID = mPalace(game);
                if (n1 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_C");
                    game.TriggerFireDamage(mIDTaxOffice, (int)n1, 99);
                }
                else if (mID != 0)
                {
                    DisplayRiot(game, "Tax_Riot_P");
                    game.TriggerFireDamage(mID, 1, 99);
                }
                else if (n2 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_F");
                    game.TriggerFireDamage(mIDForum, 1, 99);
                }
                else if (n3 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_B");
                    game.TriggerFireDamage(mIDBasilica, 1, 99);
                }
            }
            tPayCheck += 20;
        }

        //////////////////////////////////////////
        // Send 'tutorial message' to player
        void DisplayTutorial(IGameQueryInterface game)
        {
            string msgBegin = "Tutorial_";
            string sIntro;
            string[] sIndex = { "25", "20", "24", "23", "27", "07", "26", "03", "16", "09", "02", "21", "01" };
            msgTitle = msgBegin + iLabor.ToString() + "_Title";
            msgText = msgBegin + iLabor.ToString() + "_Message";
            sIntro = "/../../Voice/Figures/actor_" + sIndex[iLabor] + ".mp3";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref sIntro);
            iState++;
        }


        /////////////////////////////////////////////
        // Send message with applause to player
        void GiveAcclamation(IGameQueryInterface game)
        {
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send basic message to player
        void DisplayMessage(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send basic message with sound to player
        void DisplaySMessage(IGameQueryInterface game, String sMessage, String msgVoice)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgVoice);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send 'warning' to player
        void DisplayWarning(IGameQueryInterface game, String msgWarn)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
            bMessageSent = true;
        }

        /////////////////////////////////////////////
        // Send silent 'warning' to player
        void SilentWarning(IGameQueryInterface game, String msgWarn)
        {
            String msgNone = "";
            game.SendWarningMessage(ref msgWarn, ref msgNone);
            bMessageSent = true;
        }

        //////////////////////////////////////////////
        // Send timer warning message
        void TimerMessage(IGameQueryInterface game)
        {
            DisplayWarning(game, (sTimeLeft[iMessage] + "_Months_Left"));
            iMessage++;
        }

        //////////////////////////////////////////
        // Send 'riot warning' to player
        void DisplayRiot(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgRiot);
            bMessageSent = true;
        }

        //////////////////////////////////////////////////////////////
        // Adjust Pleb & Equite wage expectations each year from 74AD
        void CheckWageExpectations(IGameQueryInterface game)
        {
            if (nTime > 1900)
            {
                nPlebWages += 3;
                nEquiteWages += 4;
                game.SetRomeStandardRate(true, nPlebWages);
                game.SetRomeStandardRate(false, nEquiteWages);
                // now advise player of raised expectations
                DisplayMessage(game, "Wage_Change");
            }
            game.UnlockUIControl(989726641, Toolset.AdvisorsFormID);
            tWageCheck += 960;
        }

        /////////////////////////////////////////////////
        // Returns > 0 if palace built (1, 3 or 5) else 0
        Int32 mPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return mIDPalace3;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return mIDPalace2;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return mIDPalace1;
            return 0;
        }

        /////////////////////////////////////////////////////////////////////////
        // set control panel buttons to their correct state
        void CheckBaseUI(IGameQueryInterface game)
        {
            if (nTime >= 960) game.UnlockUIControl(989726641, Toolset.AdvisorsFormID);
            if (iLabor > 0) game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            if (uLabor > 0) game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);   // this is actually correct, BTW!
            if (uLabor > 1) game.UnlockUIControl(-520227242, Toolset.EmpireLevelFormID);
            if (uLabor > 2)
            {
                game.UnlockUIControl(mUIIDBarber, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDBathhouse, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDWage2, Toolset.AdvisorsFormID);
                game.LockUIControl(mUIIDWage4, Toolset.AdvisorsFormID);
            }
            else
            {
                game.UnlockUIControl(mUIIDWage2, Toolset.AdvisorsFormID);
                game.UnlockUIControl(mUIIDWage4, Toolset.AdvisorsFormID);
            }
            if (uLabor > 3)
            {
                game.UnlockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
            }
            if (bArmory) game.UnlockUIControl(mUIIDArmory, Toolset.MainGameFormID);
            if (bCavalry)
            {
                game.UnlockUIControl(mUIIDDrillYard, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
            }
            if (uLabor > 5)
            {
                game.UnlockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDOdeum, Toolset.MainGameFormID);
            }
            if (uLabor > 6)
            {
                game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDForum, Toolset.MainGameFormID);
            }
            if (uLabor > 7)
            {
                game.UnlockUIControl(mUIIDCircus, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDSchool, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDHospital, Toolset.MainGameFormID);
            }
            if (uLabor > 8)
            {
                game.UnlockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDGateHouse, Toolset.MainGameFormID);
            }
            if (uLabor > 10)
            {
                game.UnlockUIControl(mUIIDGrapeFarm, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDBushLarge, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDBushSmall, Toolset.MainGameFormID);
            }
            if (uLabor > 11)
            {
                game.UnlockUIControl(mUIIDIronMine, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
            }
            if (bPrefects) game.UnlockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
            if (bObelisk) game.UnlockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
        }
        
        /////////////////////////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        // the value of iLabor tells us whether the buildings have been unlocked
        void ResetBaseUI(IGameQueryInterface game)
        {
            if (nTime < 960) game.LockUIControl(989726641, Toolset.AdvisorsFormID);
            if (iLabor < 1) game.LockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            if (uLabor < 1) game.LockUIControl(mUIIDColiseum, Toolset.MainGameFormID);   // this is actually correct, BTW!
            if (uLabor < 2) game.LockUIControl(-520227242, Toolset.EmpireLevelFormID);
            if (uLabor < 3)
            {
                game.LockUIControl(mUIIDBarber, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDBathhouse, Toolset.MainGameFormID);
            }
            else
            {
                game.LockUIControl(mUIIDWage2, Toolset.AdvisorsFormID);
                game.LockUIControl(mUIIDWage4, Toolset.AdvisorsFormID);
            }
            if (uLabor < 4)
            {
                game.LockUIControl(mUIIDLibrary, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
            }
            if (!bArmory) game.LockUIControl(mUIIDArmory, Toolset.MainGameFormID);
            if (!bCavalry)
            {
                game.LockUIControl(mUIIDDrillYard, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDFortCavalry, Toolset.MainGameFormID);
            }
            if (uLabor < 6)
            {
                game.LockUIControl(mUIIDMarble, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDOdeum, Toolset.MainGameFormID);
            }
            if (uLabor < 7)
            {
                game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDForum, Toolset.MainGameFormID);
            }
            if (uLabor < 8)
            {
                game.LockUIControl(mUIIDCircus, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDSchool, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDHospital, Toolset.MainGameFormID);
            }
            if (uLabor < 9)
            {
                game.LockUIControl(mUIIDFortArcher, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGateHouse, Toolset.MainGameFormID);
            }
            if (uLabor < 11)
            {
                game.LockUIControl(mUIIDGrapeFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDBushLarge, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDBushSmall, Toolset.MainGameFormID);
            }
            if (uLabor < 12)
            {
                game.LockUIControl(mUIIDIronMine, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDBasilica, Toolset.MainGameFormID);
            }
            if (!bPrefects) game.LockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
            if (!bObelisk) game.LockUIControl(mUIIDObelisk, Toolset.MainGameFormID);
            game.LockUIControl(989726645, Toolset.AdvisorsFormID);
            if (nTime > 0) game.LockUIControl(1942421155, Toolset.AdvisorsFormID);
        }
        
        void OnBeginScenario(IGameQueryInterface game)
        {
            mMilitaryAI = new TMilitaryAI(game);
            game.SetRomeStandardRate(true, nPlebWages);
            game.SetRomeStandardRate(false, nEquiteWages);
            
            bInit = true;
            game.ScriptDone = false;
        }

        // Initialization needed on scenario load (when loading save games)
        // specifically, make sure the ScriptDone flag is set (for older save games)
        void OnScenarioLoad(IGameQueryInterface game)
        {
            bInit = true;
            game.ScriptDone = false;
        }

        void OnInvasionArrival(IGameQueryInterface game)
        {
            Int32[] enemyCohorts;
            String invasion = game.RunInvasion;
            // Geeks targetting all entertainment venues!
            String[] sTargets = { "C4b service Odeum","C4b service Theater","C4b service Arena","C4b Service Coliseum","C4b service Circus",
            "C4b Training Actor","C4b Training Animal","C4b Training Gladiator","C4b Training Charioteer" };
            String orders = "RazeBuildings";
            game.GetInvaderCohorts(ref invasion, out enemyCohorts);
            foreach (Int32 cohortID in enemyCohorts)
            {
                game.SetCohortOrders(cohortID, ref orders);
                game.SetCohortTargets(cohortID, ref sTargets);
            }
        }

        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            // do nothing - carry on
        }
    }
}
